<?php
   /*
   CheckCOntent
   (c) 2007 by S TAYEFEH

   Check string for illegal stuff.
   The constructur needs one single string argument, that contains the
   URI to the blacklist.txt file. This list contains one word per line of
   words that must not occur in the string to validate.

   Example use:

      require_once "CheckContent.php";
      $val = new CheckContent("pbblacklist.txt");
      if ($val->validate("ueh i hiru hrie wiu hwiu hwitu")) echo "ok";
      else echo "failed";

   */

   class CheckContent
   {
      public $blacklistFN; // The textfile with the list of prohibited expressions
      public $content="";  // The content to check - A single string
      private $blacklistA=array();
      private $isValid=TRUE;

      // constructor
      public function CheckContent($blacklist)
      {
	 $this->isValid=TRUE;
	 $this->blacklistFN=$blacklist;
	 $this->content="EMPTY";
      }

      // Main Method
      public function validate($content)
      {
	 $this->content=$content;
	 if(!$this->readFile()) return FALSE;

	 foreach ($this->blacklistA as $a)
	 {
	    if(preg_match('/'.$a.'/i',$content)) $this->isValid=FALSE;
	 }
	 return $this->isValid;
      }

      // Read File
      private function readFile()
      {
	 $blacklistTemp=array();
	 $blacklistS=FALSE;
	 $blacklistS=file_get_contents($this->blacklistFN);
	 if (!$blacklistS) 
	  {
	     echo "*** ERROR from CheckContent:: - Could not read blacklist file: ".$this->blacklistFN;
	     return FALSE;
	  }
	 $blacklistTemp=explode("\n",$blacklistS);
	 // Clean array
	 $this->blacklistA=array();
	 // Only lines that contain letters or digits
	 foreach ($blacklistTemp as $a) if( ereg("[a-zA-Z0-9]",$a) ) array_push($this->blacklistA,trim($a));
	 sort($this->blacklistA); // Cosmetic ;-)
	 return TRUE;
      }
   }

